;
;Include file ring-3 InputOutput functions(standart Kernel call)
;


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Input:edx=offset of filename

fopen  proc

       pushad

       xor ebx,ebx

       push ebx
       push FILE_ATTRIBUTE_NORMAL
       push OPEN_EXISTING
       push ebx
       push FILE_SHARE_READ + FILE_SHARE_WRITE
       push GENERIC_READ + GENERIC_WRITE
       push edx
       call CreateFileA

       inc eax                 ;eax=-1?
       jz fopen_exit
       dec eax

fopen_exit:

       mov [esp._eax], eax
       popad
       retn
fopen  endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;in :ebx=handle

f_createmap  proc
       pusha

       xor eax,eax
       push eax			    ;for mapvievoffile

       push eax			    ;name
       push eax                     ;lowsize
       push eax                     ;highsize
       push PAGE_READWRITE
       push eax
       push ebx
       call CreateFileMappingA

       xchg ebx,eax

       pop eax			    ;null
       push eax			    ;count bytes
       push eax                     ;lowsize
       push eax                     ;highsize
       push 2;FILE_MAP_ALL_ACCESS	
       push ebx
       call MapViewOfFile

       jmp short fopen_exit	
f_createmap  endp 



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
f_closemap  proc
       pusha
       push ebx
       call UnmapViewOfFile
       popa
       retn
f_closemap  endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Input:ebx=handle

fclose proc

       pushad

       push ebx
       call CloseHandle

       popad
       retn
fclose endp



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Input:ebx=handle file
;      ecx=count of bytes to move
fseek  proc

       pushad

       push FILE_BEGIN
       push 0
       push ecx
       push ebx
       call SetFilePointer

       popad
       retn
fseek  endp



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Input:ebx=handle file
;      ecx=count of bytes to write
;      edi=offset of bufer

fwrite  proc

       pushad

       push eax
	mov eax,esp
       push 0


	push eax				       			;push 4 ptr [ebp+offset bytesread @ex]
       push ecx
       push edi

       push ebx
       call WriteFile

	jmp short _clear_exit
fwrite  endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Input:ebx=handle file
;      ecx=count of bytes to read
;      edx=offset of bufer
fread  proc

       pushad

       push eax
       mov eax,esp					;save for bytesRead	

       push 0
      	
       push eax						;bytes read
       push ecx
       push edx
       push ebx
       call ReadFile

_clear_exit:

       pop ebp						;clear stack
       popad
       retn                                             ;& return
fread  endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ebx=handle
fsize 	proc
	pusha

	push 0
	push ebx
	call GetFileSize
	mov [esp._eax],eax

	popa
	retn
fsize  	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ebx=handle
set_EOF 	proc
		pusha
		push ebx
		call SetEndOfFile
		popa
		retn
set_EOF 	endp
