
; Output flags format:
; ~~~~~~~~~~~~~~~~~~~~
;
;                         operand
;operand   reg1   r2_base  prefix
;                        
;                        
; Ŀ
;  7  6  5  4  3  2  1  0 
; 
;                            
;                            
;     index   offset   just   memory
;                     prefix  prefix
;


OUT_FLAG_OPERAND                equ             10000000b
OUT_FLAG_INDEX                  equ             01000000b
OUT_FLAG_REG1                   equ             00100000b
OUT_FLAG_OFFSET                 equ             00010000b
OUT_FLAG_REG2BASE               equ             00001000b
OUT_FLAG_JUST_PREFIX            equ             00000100b
OUT_FLAG_O_PREFIX               equ             00000010b
OUT_FLAG_A_PREFIX               equ             00000001b


; Output extended flags format:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;                W-bite state
;                             modr_m
;                            /
;ex-flags:      Ŀ
;                7  6  5  4  3  2  1  0 
;               
;                                \sib
;                        
;              D state  regmem [reg=0;mem=1]

EXT_D_STATE         		equ     	10000000b       ;(d=1  mem->reg  /d=0  mem<-reg  )
EXT_W_STATE        		equ     	01000000b       ;(0-work with bytes /1-work with dwords/words)
EXT_REG_MEM         		equ     	00100000b

EXT_MODRM         		equ     	00010000b
EXT_SIB         		equ     	00001000b

;                   ķ   ķ  ķ
;                   modr/m Ĵprefix state  reg/kop
;                   Ѽ  ͼ  ͼ
;format:                              
;                                 Ŀ
;          
;          7 6 5432107 65 432 1 0
;          Ľ
;                        Ŀ
;                    Ŀ   Ŀ        
;             Ŀ Ŀ                   
;    ķ ķ  ķ  ķ  ķ  ķ
;    len_mask1 0f   cop    d(1)/s(0)  operand  cop
;    ͼ ͼ  needed  ͼ  ͼ  ͼ
;                      ͼ

MASK1_2                         equ             00100000b
MASK1_3                         equ             01000000b
MASK1_4                         equ             01100000b
MASK1_5                         equ             10000000b
MASK1_6                         equ             10100000b
MASK1_7                         equ             11000000b
FULL_MASK1                      equ             11100000b

EX_0F                           equ             00010000b
EXEPT_NEED                      equ             00001000b
MODR_M                          equ             00000001b
DW_EXIST                        equ             00000010b


ENABLE_EXEPT1                   equ             00000001b
ENABLE_EXEPT2                   equ             00000010b
ENABLE_EXEPT3                   equ             00000100b

C_OP                            equ             00001000b
OP_NO_OPERAND                   equ             00000000b
OP_BYTE_OPERAND                 equ             00010000b
OP_DWORD_OPERAND                equ             00100000b
OP_JUST_OPERAND                 equ             00110000b

A_PREFIX                        equ             01000000b
O_PREFIX                        equ             10000000b
_PREFIX                         equ             11000000b

EXEPT_OP_1                      equ             00000111b		;for 0xff opcode
EXEPT_OP_2                      equ             00000000b
EXEPT_OP_3                      equ             00000000b

;##############################################################################
; DIZX32 structures
;##############################################################################
opcode          struc
                 mask_flag       db      0
                 modr_m_flag     db      0
                 mask1           db      0
                 mask2           db      0
                ends

output          struc
                 com_size       db      0
                 prefix_size    db      0

		 sib  		db	0
		 modrm          db	0

                 o_flags        db      0
                 ex_flags       db      0

                 index_reg      db      0
                 reg2_base      db      0
                 reg1           db      0

                 size_mem       db      0
                 size_operand   db      0

                 mem_offset     dd      0
                 operand        dd      0

                 descryptor     opcode<>
                ends